<template>
  <GenericLayout>
    <template #header>
      <Header
        fastplatform-logo
        :title="pageTitle"
        :badge-content="pageSubTitle"
      />
    </template>
    <template #page-content>
      <div
        style="height: 100%;"
      >
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <div
          v-if="loading"
          class="column flex-center q-ma-md"
        >
          <q-spinner-dots
            color="primary"
            size="40px"
          />
        </div>

        <template v-else-if="holding_campaign">
          <div
            class="text-body2 q-mb-lg"
            :class="{'page-default-padding-x': !isDesktopPlatform}"
            v-if="holding_campaign.sites.length > 1"
          >
            <SiteSelection
              v-model="selectedSiteId"
              :sites="holding_campaign.sites"
              :authorize-no-value="false"
            />
          </div>
          <q-card :square="!isDesktopPlatform">
            <HoldingCampaignMap
              :map-style="'height: 350px;'"
              :centroid="selectedSiteCentroid"
              :site-id="selectedSiteId"
            />
          </q-card>

          <div
            class="text-subtitle1 text-dark q-mb-md q-mt-lg"
            :class="{'page-default-padding-x': !isDesktopPlatform}"
          >
            <translate>Plots</translate>
          </div>
          <PlotsCard
            :site-id="selectedSiteId"
          />

          <template v-if="canDisplaySoilSite">
            <div
              class="text-subtitle1 text-dark q-mb-md q-mt-lg"
              :class="{'page-default-padding-x': !isDesktopPlatform}"
            >
              <translate>Soil samples</translate>
            </div>
            <SoilSitesCard />
          </template>

          <template v-if="canDisplayCustomFertilizer">
            <div
              class="text-subtitle1 text-dark q-mb-md q-mt-lg"
              :class="{'page-default-padding-x': !isDesktopPlatform}"
            >
              <translate>Fertilizers</translate>
            </div>
            <CustomFertilizersCard />
          </template>
        </template>

        <div
          v-else
          style="height: 100%;"
        >
          <q-card :square="!isDesktopPlatform">
            <q-card-section class="text-grey">
              <translate>No data for this campaign</translate>
            </q-card-section>
          </q-card>
        </div>
      </div>
    </template>
    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import SiteSelection from 'src/pages/holding-campaign/holding-campaign/components/SiteSelection'
import HoldingCampaignMap from 'src/pages/holding-campaign/holding-campaign/components/HoldingCampaignMap'
import PlotsCard from 'src/pages/holding-campaign/holding-campaign/components/PlotsCard'
import CustomFertilizersCard from 'src/pages/holding-campaign/custom-fertilizer/components/CustomFertilizersCard'
import SoilSitesCard from 'src/pages/holding-campaign/soil-site/components/SoilSitesCard'
import queryHoldingCampaign from 'src/pages/holding-campaign/holding-campaign/graphql/queryHoldingCampaignByPk'
import featureFlags from 'src/services/feature-flags'

export default {
  name: 'HoldingCampaignPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    SiteSelection,
    HoldingCampaignMap,
    PlotsCard,
    CustomFertilizersCard,
    SoilSitesCard
  },
  data () {
    return {
      selectedSiteId: ''
    }
  },
  apollo: {
    holding_campaign: {
      query: queryHoldingCampaign,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          holding_campaign_id: this.$store.state.fastplatform.holdingCampaign.id
        }
      },
      result ({ data }) {
        // Set the first site of the results as the selected one
        if (data?.holding_campaign?.sites.length > 0) {
          this.selectedSiteId = data.holding_campaign.sites[0].id
        } else {
          this.selectedSiteId = null
        }
      }
    }
  },
  computed: {
    pageTitle () {
      return this.$store.state.fastplatform.holdingCampaign.holding.name
    },
    pageSubTitle () {
      return this.$store.state.fastplatform.holdingCampaign.campaign.name
    },
    selectedSite () {
      if (this.selectedSiteId) {
        return this.holding_campaign.sites.find(s => s.id === this.selectedSiteId)
      } else {
        return {}
      }
    },
    loading () {
      return !this.holding_campaign && this.$apollo.queries.holding_campaign.loading
    },
    selectedSiteCentroid () {
      if (this.selectedSite && this.selectedSite.centroid) {
        return this.selectedSite.centroid
      } else {
        return null
      }
    },
    canDisplayCustomFertilizer () {
      return featureFlags.canDisplayCustomFertilizer()
    },
    canDisplaySoilSite () {
      return featureFlags.canDisplaySoilSite()
    }
  }
}
</script>
